#    
#     
#
#        
#    2008-09-27 - 2008-09-28
#

#=====================================================================
#     
#=====================================================================
$tournament = "M";      #  
$ntours = 2;            #  
$nq = 12;               #    
$qmax = $ntours * $nq;  #   
$season=2009;

#---------------------------------------------------------------------
#    
#---------------------------------------------------------------------
%ages = (96=>1, 94=>2, 92=>3, 89=>4);
%status = (''=>1, ''=>2, ''=>3, ''=>4);

#---------------------------------------------------------------------
#  ,    
#---------------------------------------------------------------------
$region;                #   
$city;                  #  ,  
$f;                     #   ,   <IN>
$line;                  #   

$errors = 0;            #  
$warning = 0;           #  

#=====================================================================
#     
#=====================================================================

#  
#      -    
require 'charset.pl';

#   
require 'messages.pl';

#    
(open PARAM, 'param.txt') or die "No param.txt: $!\n";
eval while (<PARAM>);
close PARAM;

#       ,   
if ($ARGV[0]) {
   $ARGV[0] =~ /^$tournament\w\d(.{5})/i;
   $r = $1;
}
$region = uc ($r || $region);
$city = getcityname($region);

#---------------------------------------------------------------------
#    
#---------------------------------------------------------------------

die $msg_nout if $screen_code eq ''  &&  $file_code eq '';

%charset = ('dos' => 'dos',  'win' => 'win',  'koi' => 'koi',  '' => 'empty');

die $msg_badscreencode unless $charset{$screen_code};
$screen_charset = "${$screen_code}";

die russian ($msg_badfilecode, $innercode, $screen_charset) unless $charset{$file_code};
$file_charset = "${$file_code}";

$file_code && ((open OUT, ">$file_name") ||
   die russian ("$msg_cannotcreatefile: $!\n", $innercode, $screen_charset));

error('i',$msg_start);
$DBTEST = -e 'testdb.pl';
require 'testdb.pl' if $DBTEST;
require 'testnames.pl' if $DBTEST;

1;

#=====================================================================
#   
#=====================================================================

sub russian
#  
# : russian(, _, _)
# : _ = $innercode (  )
#            _ = $screen_charset (  )
# :  
{
   my $message = $_[0];
   my $code1 = $_[1] || $innercode;
   my $code2 = $_[2] || $screen_charset;
   eval '$message =~'."tr/$code1/$code2/";
   return $message;
}

sub lat2rus
#       
# : lat2rus()
#       
# : void
{
   $_[0] =~ tr/ABCEHKMOPTX//;
}

sub small2caps
#      
# : small2caps()
#       
# : void
{
   $_[0] =~ tr/-/-ߨ/;
}

sub all2ruscaps
#     :
#        ,
#         
# : void
{
   $_[0] = uc $_[0];
   small2caps($_[0]);
   lat2rus($_[0]);
}

sub error
#  
# : error(, )
#      -  .
#         : i -  ,   
#                             w - ,   
#       ,
#            
# : void
{
   my $level;
   if    ($_[0] eq 'i') {$level = "";               shift;}
   elsif ($_[0] eq 'w') {$level = "* "; $warning++; shift;}
   else                 {$level = "! "; $errors++;}
   eval '$message=qq/'."$level$_[0]/";
   my $m;
   if ($screen_charset) {
      $m = russian($message, $innercode, $screen_charset);
      print "$m\n";
   }
   if ($file_charset) {
      $m = russian($message, $innercode, $file_charset);
      print OUT "$m\n";
   }
}

sub getcityname
#   
# : getcityname()
# :     
{
   my ($code,$name,$person,$answer);
   (open CITIES,"cities.txt") || error ($msg_nocitieslst);
   $answer = '';
   while (<CITIES>)
   {
      ($code,$name,$person) = /^(\S+)\s+(.*) +\((.*)\)/;
      if ($code eq $_[0]) {
         $answer = $name;
         last;
      }
   }
   close CITIES;
   return $answer;
}

sub testhead
#     
# : testhead()
#   ,      
# : void
{
   $line=1;
   $in_charset = setcode ($_ = <IN>);
   unless ($in_charset)
   {
      error ($msg_nocharsetinfile, $f);
      $in_charset = $innercode;
   }
   $_ = russian ($_, $in_charset, $innercode);
   error ($msg_badfirstline, $f) unless /^\s*$head_line1\s*$/;
   $_=<IN>; #  
   newline();
   if (/^(\w+)\s+(.+?)\s*,\s*(.+?)$/) {
      error ($msg_badcitycode, $f, $1) unless $1 eq $region;
      error ($msg_badcityname, $f, $3) unless $3 eq $city;
   } else {
      error ($msg_badsecondline, $f);
   }
   $_ = <IN>; #  
   newline();
   error ($msg_badthirdline, $f) unless /^$head_line3\s+(\d)$/;
   error ($msg_H_badtournumber, $f) unless $stage==$1;
}

sub newline
#    
# : newline()
#    ,      
# :  , ,   
{
   $line++;
   $_ = russian ($_, $in_charset, $innercode);
   chomp;
   s/^\s*//; s/\s*$//;
   return (/^$/ || /^%/);
}

sub setperson
{
   ($fullname,$birthday,$school,$tours) = split /\s*\|\s*/;

   ($name,$surname,$middlename) = split /\s+/,$fullname;
   ($d,$m,$y) = split /[\.\/]/,$birthday;
   all2ruscaps($school);
   ($status,$class) = $school =~ /^(.)\s*(\d+)?$/;
   all2ruscaps($tours);
   $tours =~s/\s//g;
   return;
}

sub setTeam
#       (  I  P)
# : setTeam()
#   ,    
# : void
{
   ($teamcode, $teamgroup, $teamname, $teamcap, $teamcity) = split /\s*\|\s*/;
   all2ruscaps($teamgroup);
   ($teamstatus,$teamage) = ($teamgroup =~ /^(.)\s*(\d\d)$/);
}

sub find_status
#   
# : find_status ($school)
# :  
{
   return '' if $_[0] =~ /^\s*[1-7]$/;
   return '' if $_[0] =~ /^\s*\d$/;
   return '' if $_[0] =~ /^/;
   return '';
}

sub find_age
#    
# : find_age ($year)
# :  
{
   return 96 if $_[0]>=1996;
   return 94 if $_[0]>=1994;
   return 92 if $_[0]>=1992;
   return 89;
}
